/* PKI_INTEGER */

#include <libpki/pki.h>

PKI_INTEGER *PKI_INTEGER_new_char( char *val ) {
	PKI_INTEGER *ret = NULL;

	ret = (PKI_INTEGER *) s2i_ASN1_INTEGER( NULL, val );
	return( ret );
}

PKI_INTEGER *PKI_INTEGER_new( long long val ) {

	PKI_INTEGER *ret = NULL;

	if((ret = (PKI_INTEGER *) ASN1_INTEGER_new()) == NULL ) {
		return ( NULL );
	}

	ASN1_INTEGER_set((ASN1_INTEGER *) ret, val );

	return( ret );
}

void PKI_INTEGER_free_void( void *i ) {
	int ret;

	ret = PKI_INTEGER_free( (PKI_INTEGER *) i);
	return;
}

int PKI_INTEGER_free( PKI_INTEGER *i ) {

	if( !i ) return (PKI_ERR);

	ASN1_INTEGER_free( (ASN1_INTEGER *) i );

	return (PKI_OK);
}

char *PKI_INTEGER_get_parsed ( PKI_INTEGER *i ) {

	char *ret = NULL;

	if( !i ) return (NULL);

	ret = i2s_ASN1_INTEGER( NULL, (ASN1_INTEGER *) i );

	return( ret );

}

