/* openssl/pki_x509_pkcs7.c */

#include <libpki/pki.h>

void PKI_PKCS7_free ( PKI_PKCS7 *p7 ) {

	if( p7 == NULL ) return;

	PKCS7_free( (PKCS7 *) p7 );

	return;
}

PKI_PKCS7 *PKI_PKCS7_new ( unsigned char *data, size_t size,
			PKI_KEYPAIR *sign_key, PKI_X509_CERT *enc_cert,
			PKI_DIGEST_ALG *dgst, PKI_ALGOR *enc_alg, int flags ) {

	return ( NULL );
}

PKI_PKCS7 *PKI_PKCS7_TK_new ( unsigned char *data, size_t size,
			PKI_TOKEN *sign_tk, PKI_TOKEN *enc_tk,
			PKI_DIGEST_ALG *dgst, PKI_ALGOR *enc_alg, int flags ) {

	return ( NULL );
}

PKI_PKCS7 *PKI_PKCS7_new_by_name ( unsigned char *data, size_t size,
			PKI_KEYPAIR *sign_key, PKI_X509_CERT *enc_cert,
			char *dgst_s, char *enc_alg_s, int flags ) {
}

PKI_PKCS7 *PKI_PKCS7_TK_new_by_name ( unsigned char *data, size_t size, 
			PKI_TOKEN *sign_tk, PKI_TOKEN *enc_tk,
			char *dgst_s, char *enc_alg_s, int flags ) {
}

PKI_PKCS7 *PKI_PKCS7_MEM_new ( PKI_MEM *mem, 
			PKI_TOKEN *sign_tk, PKI_TOKEN *enc_tk, 
			PKI_DIGEST_ALG *dgst, PKI_ALGOR *enc_alg, int flags ) {

	return ( PKI_PKCS7_TK_new( mem->data, mem->size,
			sign_tk, enc_tk, dgst, enc_alg, flags ) );
}

PKI_PKCS7 *PKI_PKCS7_MEM_new_by_name ( PKI_MEM *mem, 
			PKI_TOKEN *sign_tk, PKI_TOKEN *enc_tk, 
			char *dgst_s, char *enc_alg_s, int flags ) {

	PKI_DIGEST_ALG *dgst_alg = NULL;
	PKI_ALGOR *enc_alg_alg = NULL;

	return ( PKI_PKCS7_TK_new( mem->data, mem->size,
			sign_tk, enc_tk, dgst_alg, enc_alg_alg, flags ) );
}

