/* TOKEN Object Management Functions */

#include <libpki/pki.h>

static int _libpki_init = 0;

/*!
 * \brief Initialize libpki internal structures.
 */

int PKI_init_all( void ) {

	/* Initialize OpenSSL so that it adds all the needed algor and dgst */
	if( _libpki_init == 0 ) {
        	X509V3_add_standard_extensions();
        	OpenSSL_add_all_algorithms();
        	OpenSSL_add_all_digests();
        	OpenSSL_add_all_ciphers();

		ERR_load_ERR_strings();
		ERR_load_crypto_strings();

		PRQP_init_all_services();
	}

	_libpki_init = 1;

	return ( PKI_OK );
}

int PKI_get_init_status ( void ) {

	if( _libpki_init == 0 ) {
		return PKI_STATUS_NOT_INIT;
	}

	return PKI_STATUS_INIT;
}
