/*
 * LibPKI - Easy-to-use PKI library
 * by Massimiliano Pala (madwolf@openca.org)
 * OpenCA project 2001-2007
 *
 * Copyright (c) 2001-2007 The OpenCA Project.  All rights reserved.
 *
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */

#include <libpki/pki.h>

/* Functions */

int strcmp_nocase( char *st1, char *st2) {
	return strncmp_nocase ( st1, st2, 0 );
}

int strncmp_nocase( char *st1, char *st2, int n) {
	int i;

	if(!st1) return(-1);
	if(!st2) return(1);

	i = 0;

	if( n < 1 ) {
		int st1_len, st2_len;

		st1_len = strlen(st1);
		st2_len = strlen(st2);
		
		n = st1_len > st2_len ? st2_len : st1_len;
	}

	while( st1[i] && st2[i] && i < n ) {

		unsigned char *pnt_a, *pnt_b;
		unsigned char a, b;

		pnt_a = (unsigned char *) st1+i;
		pnt_b = (unsigned char *) st2+i;

		if( !pnt_a &&  pnt_b ) return(-1);
		if(  pnt_a && !pnt_b ) return(1);
		if( !pnt_a && !pnt_b ) return(0);

		a = tolower( *pnt_a );
		b = tolower( *pnt_b );

		if( a != b ) {
			return ( a-b );
		}
		i++;
	}

	return(0);

}

char * strstr_nocase ( char *buf, char *string ) {

	int buf_len, string_len;
	int j,k;
	int match;

	char *ret = NULL;

	if( !buf || !string ) return (NULL);

	if( (buf_len = strlen(buf)) == 0 ) return(NULL);
	if( (string_len = strlen(string)) == 0 ) return(NULL);
	
	j = 0; match = 0;
	while( j < buf_len ) {
		unsigned char a, b;
		unsigned char *pnt_a, *pnt_b;

		pnt_a = (unsigned char *) (buf+j);
		pnt_b = (unsigned char *) (string);

		for( k = 0; k < string_len; k++ ) {
			a = (unsigned char) tolower(*(buf+j+k));
			b = (unsigned char) tolower(*(string+k));
			if( b != a ) {
				match=0;
				break;
			} else {
				match=1;
			}
		}
		if( match == 1 ) {
			return( buf+j );
		}
		j++;
	}

	return(ret);
}

