
#include <libpki/pki.h>

int log_operations ( void ) {

	PKI_log( PKI_LOG_NONE, 
			"%s:%d:: LOG_NONE\n", __FILE__, __LINE__ );

	PKI_log( PKI_LOG_ERR, 
			"%s:%d:: LOG_ERR\n", __FILE__, __LINE__ );

	PKI_log( PKI_LOG_WARNING, 
			"%s:%d:: LOG_WARNING\n", __FILE__, __LINE__ );

	PKI_log( PKI_LOG_NOTICE, 
			"%s:%d:: LOG_NOTICE\n", __FILE__, __LINE__ );

	PKI_log( PKI_LOG_INFO, 
			"%s:%d:: LOG_INFO\n", __FILE__, __LINE__ );
}

int main (int argc, char *argv[] ) {

	printf("\n\nlibpki Test - Massimiliano Pala <madwolf@openca.org>\n");
	printf("(c) 2006 by Massimiliano Pala and OpenCA Project\n");
	printf("OpenCA Licensed Software\n\n");

	log_operations();

	if(( PKI_log_init (PKI_LOG_TYPE_STDERR, PKI_LOG_INFO, NULL,
			PKI_LOG_FLAGS_ENABLE_DEBUG, NULL )) == PKI_ERR ) {
		exit(1);
	}
	log_operations();
	PKI_log_end();


	if(( PKI_log_init (PKI_LOG_TYPE_SYSLOG, PKI_LOG_NOTICE, NULL,
			PKI_LOG_FLAGS_ENABLE_DEBUG, NULL )) == PKI_ERR ) {
		exit(1);
	}
	log_operations();
	PKI_log_end();


	if(( PKI_log_init (PKI_LOG_TYPE_FILE, PKI_LOG_NOTICE, 
		"results/test9.log", PKI_LOG_FLAGS_ENABLE_DEBUG, NULL )) 
								== PKI_ERR ) {
		exit(1);
	}
	log_operations();
	PKI_log_end();

	printf("\n\n[ Test Ended Succesfully ]\n\n");

	return (0);
}

